# -*- generated by 1.0.9b5 -*-
import da
PatternExpr_705 = da.pat.TuplePattern([da.pat.ConstantPattern('CLIENT_DONE'), da.pat.FreePattern('clientName'), da.pat.FreePattern('requestsFilename'), da.pat.FreePattern('messagesSent'), da.pat.FreePattern('processingStartTime'), da.pat.FreePattern('processingEndTime'), da.pat.FreePattern('CPUTime')])
PatternExpr_722 = da.pat.FreePattern('p')
PatternExpr_1325 = da.pat.TuplePattern([da.pat.ConstantPattern('CLIENT_RESULT'), da.pat.FreePattern('request')])
PatternExpr_1332 = da.pat.FreePattern('p')
PatternExpr_1784 = da.pat.TuplePattern([da.pat.ConstantPattern('WORKER_INITIAL'), da.pat.FreePattern('request')])
PatternExpr_1791 = da.pat.FreePattern('p')
PatternExpr_2440 = da.pat.TuplePattern([da.pat.ConstantPattern('GET_STATS')])
PatternExpr_2445 = da.pat.FreePattern('p')
PatternExpr_3085 = da.pat.TuplePattern([da.pat.ConstantPattern('STATS_RESULT'), da.pat.FreePattern('stats')])
PatternExpr_3092 = da.pat.FreePattern('p')
PatternExpr_3175 = da.pat.TuplePattern([da.pat.ConstantPattern('GET_STATS')])
PatternExpr_3180 = da.pat.FreePattern('p')
PatternExpr_3197 = da.pat.TuplePattern([da.pat.ConstantPattern('SUBJECT_COORDINATOR_INITIAL'), da.pat.FreePattern('request')])
PatternExpr_3204 = da.pat.FreePattern('p')
PatternExpr_3249 = da.pat.TuplePattern([da.pat.ConstantPattern('RESOURCE_COORDINATOR_INITIAL'), da.pat.FreePattern('request')])
PatternExpr_3256 = da.pat.FreePattern('p')
PatternExpr_3301 = da.pat.TuplePattern([da.pat.ConstantPattern('SUBJECT_COORDINATOR_VALIDATE'), da.pat.FreePattern('request')])
PatternExpr_3308 = da.pat.FreePattern('p')
PatternExpr_3825 = da.pat.TuplePattern([da.pat.ConstantPattern('SUBJECT_COORDINATOR_RESOURCE_CONFLICT'), da.pat.FreePattern('request')])
PatternExpr_3832 = da.pat.FreePattern('p')
PatternExpr_4056 = da.pat.TuplePattern([da.pat.ConstantPattern('SUBJECT_COORDINATOR_FINAL'), da.pat.FreePattern('request')])
PatternExpr_4063 = da.pat.FreePattern('p')
PatternExpr_4272 = da.pat.TuplePattern([da.pat.ConstantPattern('RESOURCE_COORDINATOR_VALIDATE'), da.pat.FreePattern('request')])
PatternExpr_4279 = da.pat.FreePattern('p')
PatternExpr_5058 = da.pat.TuplePattern([da.pat.ConstantPattern('ALL_CLIENTS_DONE'), da.pat.FreePattern('stats')])
PatternExpr_5064 = da.pat.FreePattern('p')
PatternExpr_5123 = da.pat.TuplePattern([da.pat.ConstantPattern('STATS_RESULT'), da.pat.FreePattern('stats')])
PatternExpr_5129 = da.pat.FreePattern('p')
PatternExpr_5549 = da.pat.TuplePattern([da.pat.ConstantPattern('MASTER_DONE')])
PatternExpr_5554 = da.pat.FreePattern('p')
PatternExpr_5744 = da.pat.TuplePattern([da.pat.ConstantPattern('MASTERMASTER_DONE')])
PatternExpr_5749 = da.pat.TuplePattern([da.pat.FreePattern(None), da.pat.TuplePattern([da.pat.FreePattern(None), da.pat.FreePattern(None), da.pat.FreePattern(None)]), da.pat.TuplePattern([da.pat.ConstantPattern('MASTERMASTER_DONE')])])
_config_object = {}
import json
import sys
import time
import mapper
import random
import Cache
import Filenames
from Logger import Logger
from datetime import datetime
from MySQLAbstraction import MySQLAbstraction
from config import *
from Cache import LRUCache, Update, Cache, debug1
from RandomStringGenerator import RandomStringGenerator
import os
import pickle
from RequestGeneratorDecat import RequestGeneratorDecat
import numpy
from RequestParser import getSubjectAttrsToRead, getResourceAttrsToRead, getObjectToWrite, isReadRequest, isWriteRequest, getAttrToWrite
from pprint import pformat

class ClientInfo():

    def __init__(self, name, processingStartTime, processingEndTime, CPUTime, messagesSent, requestsInfo):
        self.name = name
        self.processingStartTime = processingStartTime
        self.processingEndTime = processingEndTime
        self.CPUTime = CPUTime
        self.messagesSent = messagesSent
        self.requestsInfo = requestsInfo

class RequestInfo():

    def __init__(self, startTime, endTime, numRestarts):
        self.startTime = startTime
        self.endTime = endTime
        self.numRestarts = numRestarts

    def __str__(self):
        return ((((('Start time: ' + str(self.startTime)) + '; End time: ') + str(self.endTime)) + '; numRestarts: ') + str(self.numRestarts))

class ClientMaster(da.DistProcess):

    def __init__(self, procimpl, props):
        super().__init__(procimpl, props)
        self._events.extend([da.pat.EventPattern(da.pat.ReceivedEvent, '_ClientMasterReceivedEvent_0', PatternExpr_705, sources=[PatternExpr_722], destinations=None, timestamps=None, record_history=None, handlers=[self._ClientMaster_handler_704])])

    def setup(self, coordIndexToCoordProcessMapper, config, master, **rest_5759):
        super().setup(coordIndexToCoordProcessMapper=coordIndexToCoordProcessMapper, config=config, master=master, **rest_5759)
        self._state.coordIndexToCoordProcessMapper = coordIndexToCoordProcessMapper
        self._state.config = config
        self._state.master = master
        self._state.coordIndexToCoordProcessMapper = self._state.coordIndexToCoordProcessMapper
        self._state.config = self._state.config
        seed = self._state.config['seedBaseDecat']
        self._state.master = self._state.master
        self._state.name = '<ClientMaster>'
        self._state.numClientsDone = 0
        self._state.finished = False
        self._state.startCPUTime = None
        self._state.endCPUTime = None
        self._state.clientStats = []
        self._state.logger = Logger(Filenames.getClientLogFilename(self._state.config))
        coord1Objs = []
        coord2Objs = []
        coordResponsibleForObjects = {1: [], 2: []}
        for i in range(1, (int(self._state.config['nObj']) + 1)):
            responsibleCoordinator = mapper.getCoordinatorIndex(i)
            coordResponsibleForObjects[responsibleCoordinator].append(i)
        lastSubjectId = int((int(self._state.config['nObj']) / 2))
        lastResourceId = int(self._state.config['nObj'])
        requestGenerator = RequestGeneratorDecat(seed, range(1, (lastSubjectId + 1)), range((lastSubjectId + 1), (lastResourceId + 1)), coordResponsibleForObjects[1], coordResponsibleForObjects[2], float(self._state.config['pWrite']), float(self._state.config['pSameCoord']))
        self._state.logger.write('Creating clients')
        nClient = int(self._state.config['nClient'])
        self._state.clientSet = self.new(Client, num=nClient)
        clientList = list(self._state.clientSet)
        nRequest = int(self._state.config['nRequest'])
        defaultRequestsPerClient = int((nRequest / nClient))
        lastRequestsPerClient = (nRequest - ((nClient - 1) * defaultRequestsPerClient))
        for i in range(0, (nClient - 1)):
            requests = []
            for j in range(defaultRequestsPerClient):
                requests.append(requestGenerator.generateNext())
            requestsFilename = Filenames.getTmpRequestFilename(self._state.config, i)
            pickle_out = open(requestsFilename, 'wb')
            pickle.dump(requests, pickle_out)
            pickle_out.close()
            client = clientList[i]
            self._setup(client, (self._state.coordIndexToCoordProcessMapper, self._state.logger, self._id, requestsFilename, (i + 1)))
        requests = []
        for j in range(lastRequestsPerClient):
            requests.append(requestGenerator.generateNext())
        requestsFilename = Filenames.getTmpRequestFilename(self._state.config, (nClient - 1))
        pickle_out = open(requestsFilename, 'wb')
        pickle.dump(requests, pickle_out)
        pickle_out.close()
        client = clientList[(- 1)]
        self._setup(client, (self._state.coordIndexToCoordProcessMapper, self._state.logger, self._id, requestsFilename, nClient))
        self._state.logger.write('All clients set up')

    def run(self):
        self._state.startCPUTime = time.process_time()
        self._state.logger.write('Starting up client(s)')
        self._start(self._state.clientSet)
        super()._label('_st_label_1177', block=False)
        _st_label_1177 = 0
        while (_st_label_1177 == 0):
            _st_label_1177 += 1
            if self._state.finished:
                _st_label_1177 += 1
            else:
                super()._label('_st_label_1177', block=True)
                _st_label_1177 -= 1

    def _ClientMaster_handler_704(self, clientName, requestsFilename, messagesSent, processingStartTime, processingEndTime, CPUTime, p):
        self._state.logger.write(((((((((((self._state.name + " received ('CLIENT_DONE', ") + requestsFilename) + ', ') + str(messagesSent)) + ', ') + str(processingStartTime)) + ', ') + str(processingEndTime)) + ') from ') + str(p)))
        requestsFile = open(requestsFilename, 'rb')
        requests = pickle.load(requestsFile)
        requestsFile.close()
        os.remove(requestsFilename)
        self._state.clientStats.append(ClientInfo(clientName, processingStartTime, processingEndTime, CPUTime, messagesSent, requests))
        self._state.numClientsDone += 1
        if (self._state.numClientsDone == int(self._state.config['nClient'])):
            self._state.endCPUTime = time.process_time()
            CPUTime = (self._state.endCPUTime - self._state.startCPUTime)
            stats = {}
            stats['clients'] = {'list': [], 'aggregate': {}}
            stats['requests'] = {}
            latencies = []
            processingStartTimesList = []
            processingEndTimesList = []
            clientElapsedTimesList = []
            restartStats = {}
            numRestarts = 0
            messagesSent = 0
            totalRequests = int(self._state.config['nRequest'])
            for clientInfo in self._state.clientStats:
                messagesSent += clientInfo.messagesSent
                elapsedTime = (clientInfo.processingEndTime - clientInfo.processingStartTime)
                clientElapsedTimesList.append(elapsedTime)
                stats['clients']['list'].append({'processingStartTime': clientInfo.processingStartTime, 'processingEndTime': clientInfo.processingEndTime, 'messagesSent': clientInfo.messagesSent, 'CPUTime': clientInfo.CPUTime, 'elapsedTime': elapsedTime, 'name': clientInfo.name})
                processingStartTimesList.append(clientInfo.processingStartTime)
                processingEndTimesList.append(clientInfo.processingEndTime)
                for r in clientInfo.requestsInfo:
                    numRestarts += r.numRestarts
                    latencies.append((r.endTime - r.startTime))
                    if (not (r.numRestarts in restartStats)):
                        restartStats[r.numRestarts] = 0
                    restartStats[r.numRestarts] += 1
            fConflict = (numRestarts / int(self._state.config['nRequest']))
            stats['clients']['aggregate']['messagesSent'] = messagesSent
            stats['clients']['aggregate']['processingStartTimeStdDev'] = numpy.std(processingStartTimesList)
            stats['clients']['aggregate']['processingEndTimeStdDev'] = numpy.std(processingEndTimesList)
            stats['clients']['aggregate']['fractionalStdDevElapsedTime'] = (numpy.std(clientElapsedTimesList) / numpy.mean(clientElapsedTimesList))
            stats['clients']['aggregate']['processingTime'] = (numpy.max(processingEndTimesList) - numpy.min(processingStartTimesList))
            stats['requests']['numRestarts'] = numRestarts
            stats['requests']['restartStats'] = restartStats
            stats['requests']['fConflict'] = fConflict
            stats['requests']['latencyStats'] = {'min': numpy.amin(latencies), 'max': numpy.amax(latencies), 'mean': numpy.mean(latencies), 'std': numpy.std(latencies)}
            self._state.logger.write('All clients done')
            self._state.logger.write(((((self._state.name + " sending ('ALL_CLIENTS_DONE, ") + str(stats)) + ') to ') + str(self._state.master)))
            self.send(('ALL_CLIENTS_DONE', stats), to=self._state.master)
            self._state.finished = True
    _ClientMaster_handler_704._labels = None
    _ClientMaster_handler_704._notlabels = None

class Client(da.DistProcess):

    def __init__(self, procimpl, props):
        super().__init__(procimpl, props)
        self._events.extend([da.pat.EventPattern(da.pat.ReceivedEvent, '_ClientReceivedEvent_0', PatternExpr_1325, sources=[PatternExpr_1332], destinations=None, timestamps=None, record_history=None, handlers=[self._Client_handler_1324])])

    def setup(self, coordIndexToCoordProcessMapper, logger, clientMaster, requestsFilename, index, **rest_5759):
        super().setup(coordIndexToCoordProcessMapper=coordIndexToCoordProcessMapper, logger=logger, clientMaster=clientMaster, requestsFilename=requestsFilename, index=index, **rest_5759)
        self._state.coordIndexToCoordProcessMapper = coordIndexToCoordProcessMapper
        self._state.logger = logger
        self._state.clientMaster = clientMaster
        self._state.requestsFilename = requestsFilename
        self._state.index = index
        self._state.coordIndexToCoordProcessMapper = self._state.coordIndexToCoordProcessMapper
        self._state.logger = self._state.logger
        self._state.processingStartTime = None
        self._state.processingEndTime = None
        self._state.startCPUTime = None
        self._state.endCPUTime = None
        self._state.messagesSent = 0
        self._state.finished = False
        self._state.requestsFilename = self._state.requestsFilename
        requestsFile = open(self._state.requestsFilename, 'rb')
        self._state.requests = pickle.load(requestsFile)
        requestsFile.close()
        self._state.numRequestsToSend = len(self._state.requests)
        self._state.curRequestToSend = 0
        self._state.requestsInfo = []
        self._state.name = (('<Client ' + str(self._state.index)) + '>')
        self._state.numRequestsEvaluated = 0
        self._state.clientMaster = self._state.clientMaster
        self._state.logger.write((self._state.name + ' set up'))

    def run(self):
        self._state.logger.write((self._state.name + ' is running'))
        self._state.startCPUTime = time.process_time()
        self._state.processingStartTime = time.perf_counter()
        self.sendRequest()
        super()._label('_st_label_1610', block=False)
        _st_label_1610 = 0
        while (_st_label_1610 == 0):
            _st_label_1610 += 1
            if self._state.finished:
                _st_label_1610 += 1
            else:
                super()._label('_st_label_1610', block=True)
                _st_label_1610 -= 1

    def sendRequest(self):
        state = 'CLIENT'
        request = self._state.requests[self._state.curRequestToSend]
        self._state.curRequestToSend += 1
        request['client'] = self._id
        request['numRestarts'] = 0
        coord = mapper.getCoordinator(request['obj1Id'], self._state.coordIndexToCoordProcessMapper)
        self._state.logger.write(((("Client sending ('SUBJECT_COORDINATOR_INITIAL', " + str(request)) + ') to ') + str(coord)))
        self._state.messagesSent += 1
        request['startTime'] = time.perf_counter()
        self.send(('SUBJECT_COORDINATOR_INITIAL', request), to=coord)

    def _Client_handler_1324(self, request, p):
        request['endTime'] = time.perf_counter()
        self._state.requestsInfo.append(RequestInfo(request['startTime'], request['endTime'], request['numRestarts']))
        state = 'CLIENT_RESULT'
        self._state.logger.write(((((((self._state.name + " received ('") + state) + "', ") + str(request)) + ') from ') + str(p)))
        self._state.numRequestsEvaluated += 1
        if (self._state.numRequestsEvaluated >= self._state.numRequestsToSend):
            self._state.processingEndTime = request['endTime']
            self._state.endCPUTime = time.process_time()
            CPUTime = (self._state.endCPUTime - self._state.startCPUTime)
            pickle_out = open(self._state.requestsFilename, 'wb')
            pickle.dump(self._state.requestsInfo, pickle_out)
            pickle_out.close()
            self._state.logger.write(((((self._state.name + "sending ('CLIENT_DONE', ") + str(self._state.requestsFilename)) + ',) to ') + str(self._state.clientMaster)))
            self.send(('CLIENT_DONE', self._state.name, self._state.requestsFilename, self._state.messagesSent, self._state.processingStartTime, self._state.processingEndTime, CPUTime), to=self._state.clientMaster)
            self._state.finished = True
        else:
            self.sendRequest()
    _Client_handler_1324._labels = None
    _Client_handler_1324._notlabels = None

class Worker(da.DistProcess):

    def __init__(self, procimpl, props):
        super().__init__(procimpl, props)
        self._events.extend([da.pat.EventPattern(da.pat.ReceivedEvent, '_WorkerReceivedEvent_0', PatternExpr_1784, sources=[PatternExpr_1791], destinations=None, timestamps=None, record_history=None, handlers=[self._Worker_handler_1783]), da.pat.EventPattern(da.pat.ReceivedEvent, '_WorkerReceivedEvent_1', PatternExpr_2440, sources=[PatternExpr_2445], destinations=None, timestamps=None, record_history=None, handlers=[self._Worker_handler_2439])])

    def setup(self, dbNum, coordIndexToCoordProcessMapper, logger, **rest_5759):
        super().setup(dbNum=dbNum, coordIndexToCoordProcessMapper=coordIndexToCoordProcessMapper, logger=logger, **rest_5759)
        self._state.dbNum = dbNum
        self._state.coordIndexToCoordProcessMapper = coordIndexToCoordProcessMapper
        self._state.logger = logger
        self._state.logger = self._state.logger
        self._state.messagesSent = 0
        self._state.networkMessagesSent = 0
        self._state.finished = False
        self._state.startCPUTime = None
        self._state.endCPUTime = None
        if (self._state.dbNum == 1):
            dbHost = MASTER_DB_HOST
            dbUser = MASTER_DB_USER
            dbPass = MASTER_DB_PASS
        else:
            dbHost = SLAVE_DB_HOST
            dbUser = SLAVE_DB_USER
            dbPass = SLAVE_DB_PASS
        self._state.db = MySQLAbstraction(dbUser, dbPass, dbHost)
        self._state.db.connect()
        self._state.db.getCursor()
        self._state.db.selectDB(DB_NAME)
        self._state.db.setTableName(TABLE_NAME)
        self._state.randomizer = random.Random()
        self._state.randomizer.seed(time.time())
        self._state.coordIndexToCoordProcessMapper = self._state.coordIndexToCoordProcessMapper
        self._state.name = (('<Worker ' + str(self._id)) + '>')
        self._state.logger.write((self._state.name + ' set up'))

    def run(self):
        self._state.startCPUTime = time.process_time()
        self._state.logger.write((self._state.name + ' is running'))
        super()._label('_st_label_2433', block=False)
        _st_label_2433 = 0
        while (_st_label_2433 == 0):
            _st_label_2433 += 1
            if self._state.finished:
                _st_label_2433 += 1
            else:
                super()._label('_st_label_2433', block=True)
                _st_label_2433 -= 1

    def getSubjectAttrsFromCache(self, subjectAttrsToRead, request):
        attributes = {}
        tentativeSubjectUpdates = {}
        if ('tentativeSubjectUpdates' in request):
            for (requestId, update) in request['tentativeSubjectUpdates'].items():
                tentativeSubjectUpdates.update(update.attrs)
        for attr in subjectAttrsToRead:
            if (attr in tentativeSubjectUpdates):
                attributes[attr] = tentativeSubjectUpdates[attr]
            elif (attr in request['updatesFromSubjectCache'].attrs):
                attributes[attr] = request['updatesFromSubjectCache'].attrs[attr]
            else:
                print('ERROR::ERROR')
                self._state.logger.write('ERROR::ERROR')
        return attributes

    def getResourceAttrsFromCache(self, resourceAttrsToRead, request):
        attributes = {}
        for attr in resourceAttrsToRead:
            if (attr in request['updatesFromResourceCache'].attrs):
                attributes[attr] = request['updatesFromResourceCache'].attrs[attr]
            else:
                print('ERROR::ERROR')
                self._state.logger.write('ERROR::ERROR')
        return attributes

    def shadowAttrsFromDBWithThoseFromCaches(self, subjectAttrsFromDB, resourceAttrsFromDB, request):
        updatesFromResourceCache = (request['updatesFromResourceCache'] if ('updatesFromResourceCache' in request) else None)
        updatesFromSubjectCache = (request['updatesFromSubjectCache'] if ('updatesFromSubjectCache' in request) else None)
        tentativeSubjectUpdates = (request['tentativeSubjectUpdates'] if ('tentativeSubjectUpdates' in request) else None)
        if updatesFromResourceCache:
            self.shadowAttrs(resourceAttrsFromDB, updatesFromResourceCache.attrs)
        if updatesFromSubjectCache:
            self.shadowAttrs(subjectAttrsFromDB, updatesFromSubjectCache.attrs)
        if tentativeSubjectUpdates:
            for (requestId, update) in tentativeSubjectUpdates.items():
                self.shadowAttrs(subjectAttrsFromDB, update.attrs)

    def shadowAttrs(self, resultFromDb, cache):
        for (attr, value) in resultFromDb.items():
            if (attr in cache):
                resultFromDb[attr] = cache[attr]

    def canEvaluateRequestJustFromCaches(self, request):
        subjectAttrsToRead = getSubjectAttrsToRead(request)
        resourceAttrsToRead = getResourceAttrsToRead(request)
        if ('updatesFromSubjectCache' in request):
            for attr in request['updatesFromSubjectCache'].attrs:
                if (attr in subjectAttrsToRead):
                    subjectAttrsToRead.remove(attr)
        if ('tentativeSubjectUpdates' in request):
            for (requestId, update) in request['tentativeSubjectUpdates'].items():
                for attr in update.attrs:
                    if (attr in subjectAttrsToRead):
                        subjectAttrsToRead.remove(attr)
        if ('updatesFromResourceCache' in request):
            for attr in request['updatesFromResourceCache'].attrs:
                if (attr in resourceAttrsToRead):
                    resourceAttrsToRead.remove(attr)
        return ((len(subjectAttrsToRead) == 0) and (len(resourceAttrsToRead) == 0))

    def sleepIfRequested(self, state, request):
        return
        if (state in request['delay']):
            delay = int(request['delay'][state])
            self._state.logger.write((((self._state.name + ' sleeping for ') + str(delay)) + ' second(s)'))
            time.sleep(delay)
        if (state in request['delay']):
            self._state.logger.write((self._state.name + ' resumed from sleeping'))

    def _Worker_handler_1783(self, request, p):
        state = 'WORKER_INITIAL'
        self._state.logger.write(((((((self._state.name + " received ('") + state) + "', ") + str(request)) + ') from ') + str(p)))
        self.sleepIfRequested(state, request)
        subjectAttrsToRead = getSubjectAttrsToRead(request)
        resourceAttrsToRead = getResourceAttrsToRead(request)
        if self.canEvaluateRequestJustFromCaches(request):
            subjectAttrs = self.getSubjectAttrsFromCache(subjectAttrsToRead, request)
            resourceAttrs = self.getResourceAttrsFromCache(resourceAttrsToRead, request)
        else:
            subjectAttrsToRead = getSubjectAttrsToRead(request)
            subjectAttrs = self._state.db.selectNormal(request['obj1Id'], subjectAttrsToRead)
            resourceAttrsToRead = getResourceAttrsToRead(request)
            resourceAttrs = self._state.db.selectNormal(request['obj2Id'], resourceAttrsToRead)
            self.shadowAttrsFromDBWithThoseFromCaches(subjectAttrs, resourceAttrs, request)
        request['readAttributes'] = {'obj1': subjectAttrs, 'obj2': resourceAttrs}
        request['attributeUpdates'] = {'obj1': {}, 'obj2': {}}
        if isWriteRequest(request):
            objToWrite = ('obj1' if (getObjectToWrite(request) == 1) else 'obj2')
            attrToWrite = getAttrToWrite(request)
            if (attrToWrite == 'a0'):
                newVal = request['attributeUpdates'][objToWrite][attrToWrite] = (int(request['readAttributes'][objToWrite][attrToWrite]) + 1)
            else:
                newVal = self._state.randomizer.randint(1, 100)
            request['attributeUpdates'][objToWrite][attrToWrite] = newVal
        request['result'] = True
        coord = mapper.getCoordinator(request['obj1Id'], self._state.coordIndexToCoordProcessMapper)
        self._state.messagesSent += 1
        if (not (coord == p)):
            self._state.networkMessagesSent += 1
        self._state.logger.write(((((self._state.name + " sending ('SUBJECT_COORDINATOR_VALIDATE', ") + str(request)) + ') to ') + str(coord)))
        self.send(('SUBJECT_COORDINATOR_VALIDATE', request), to=coord)
    _Worker_handler_1783._labels = None
    _Worker_handler_1783._notlabels = None

    def _Worker_handler_2439(self, p):
        self._state.endCPUTime = time.process_time()
        CPUTime = (self._state.endCPUTime - self._state.startCPUTime)
        stats = {'name': self._state.name, 'messagesSent': self._state.messagesSent, 'networkMessagesSent': self._state.networkMessagesSent, 'CPUTime': CPUTime}
        self._state.db.disconnect()
        self.send(('STATS_RESULT', stats), to=p)
        self._state.finished = True
    _Worker_handler_2439._labels = None
    _Worker_handler_2439._notlabels = None

class Coordinator(da.DistProcess):

    def __init__(self, procimpl, props):
        super().__init__(procimpl, props)
        self._events.extend([da.pat.EventPattern(da.pat.ReceivedEvent, '_CoordinatorReceivedEvent_0', PatternExpr_3085, sources=[PatternExpr_3092], destinations=None, timestamps=None, record_history=None, handlers=[self._Coordinator_handler_3084]), da.pat.EventPattern(da.pat.ReceivedEvent, '_CoordinatorReceivedEvent_1', PatternExpr_3175, sources=[PatternExpr_3180], destinations=None, timestamps=None, record_history=None, handlers=[self._Coordinator_handler_3174]), da.pat.EventPattern(da.pat.ReceivedEvent, '_CoordinatorReceivedEvent_2', PatternExpr_3197, sources=[PatternExpr_3204], destinations=None, timestamps=None, record_history=None, handlers=[self._Coordinator_handler_3196]), da.pat.EventPattern(da.pat.ReceivedEvent, '_CoordinatorReceivedEvent_3', PatternExpr_3249, sources=[PatternExpr_3256], destinations=None, timestamps=None, record_history=None, handlers=[self._Coordinator_handler_3248]), da.pat.EventPattern(da.pat.ReceivedEvent, '_CoordinatorReceivedEvent_4', PatternExpr_3301, sources=[PatternExpr_3308], destinations=None, timestamps=None, record_history=None, handlers=[self._Coordinator_handler_3300]), da.pat.EventPattern(da.pat.ReceivedEvent, '_CoordinatorReceivedEvent_5', PatternExpr_3825, sources=[PatternExpr_3832], destinations=None, timestamps=None, record_history=None, handlers=[self._Coordinator_handler_3824]), da.pat.EventPattern(da.pat.ReceivedEvent, '_CoordinatorReceivedEvent_6', PatternExpr_4056, sources=[PatternExpr_4063], destinations=None, timestamps=None, record_history=None, handlers=[self._Coordinator_handler_4055]), da.pat.EventPattern(da.pat.ReceivedEvent, '_CoordinatorReceivedEvent_7', PatternExpr_4272, sources=[PatternExpr_4279], destinations=None, timestamps=None, record_history=None, handlers=[self._Coordinator_handler_4271])])

    def setup(self, coordIndexToCoordProcessMapper, config, index, master, **rest_5759):
        super().setup(coordIndexToCoordProcessMapper=coordIndexToCoordProcessMapper, config=config, index=index, master=master, **rest_5759)
        self._state.coordIndexToCoordProcessMapper = coordIndexToCoordProcessMapper
        self._state.config = config
        self._state.index = index
        self._state.master = master
        self._state.name = (('<Coordinator ' + str(self._state.index)) + '>')
        self._state.logger = Logger(Filenames.getCoordLogFilename(self._state.config, self._state.index))
        self._state.logger.write(((('Coordinator ' + str(self._id)) + ' is actually ') + str(self._state.name)))
        self._state.master = self._state.master
        self._state.startCPUTime = None
        self._state.endCPUTime = None
        self._state.messagesSent = 0
        self._state.networkMessagesSent = 0
        self._state.finished = False
        self._state.db = MySQLAbstraction(MASTER_DB_USER, MASTER_DB_PASS, MASTER_DB_HOST)
        self._state.db.connect()
        self._state.db.getCursor()
        self._state.db.selectDB(DB_NAME)
        self._state.db.setTableName(TABLE_NAME)
        self._state.coordIndexToCoordProcessMapper = self._state.coordIndexToCoordProcessMapper
        self._state.requestIdGenerator = RandomStringGenerator()
        self._state.cache = LRUCache(int(self._state.config['LRUCacheSize']))
        self._state.tentativeSubjectUpdatesCache = Cache()
        self._state.abortedRequestIds = []
        self._state.ongoingRequestIds = []
        self._state.logger.write(('Trying to create workers for ' + self._state.name))
        self._state.workerSet = self.new(Worker, num=int(self._state.config['nWorker']))
        self._state.logger.write('Trying to set up workers')
        self._setup(self._state.workerSet, (self._state.index, self._state.coordIndexToCoordProcessMapper, self._state.logger))
        self._state.logger.write('Workers created')
        self._state.workersList = list(self._state.workerSet)
        self._state.logger.write((self._state.name + ' set up'))
        self._state.numStatsReceivedFromWorker = 0
        self._state.workersStats = []

    def run(self):
        self._state.startCPUTime = time.process_time()
        self._state.logger.write('Starting workers')
        self._start(self._state.workerSet)
        self._state.logger.write((self._state.name + ' is running'))
        super()._label('_st_label_2803', block=False)
        _st_label_2803 = 0
        while (_st_label_2803 == 0):
            _st_label_2803 += 1
            if self._state.finished:
                _st_label_2803 += 1
            else:
                super()._label('_st_label_2803', block=True)
                _st_label_2803 -= 1

    def optimizedSend(self, state, request, target):
        if (self._id == target):
            self._state.logger.write(((("same coordinator optimization path taken for state '" + state) + "' and target ") + str(target)))
            if (state == 'SUBJECT_COORDINATOR_INITIAL'):
                self.processNewRequestSubject(request)
            elif (state == 'RESOURCE_COORDINATOR_INITIAL'):
                self.processNewRequestResource(request)
            elif (state == 'RESOURCE_COORDINATOR_VALIDATE'):
                self.processRequestResourceValidate(request)
            elif (state == 'SUBJECT_COORDINATOR_RESOURCE_CONFLICT'):
                self.processRequestResourceConflict(request)
            elif (state == 'SUBJECT_COORDINATOR_FINAL'):
                self.processRequestSubjectFinal(request)
            else:
                print('ERROR:ERROR:ERROR:ERROR:ERROR:ERROR:ERROR:')
                self._state.logger.write('ERROR:ERROR:ERROR:ERROR:ERROR:ERROR:ERROR:')
        else:
            self._state.networkMessagesSent += 1
            self._state.messagesSent += 1
            self._state.logger.write(((((((self._state.name + " sending ('") + state) + "', ") + str(request)) + ') to ') + str(target)))
            self.send((state, request), to=target)

    def processNewRequestSubject(self, request):
        self._state.logger.write(((self._state.name + ' received new request for processing: ') + str(request)))
        request['requestId'] = self._state.requestIdGenerator.getNext()
        self._state.ongoingRequestIds.append(request['requestId'])
        request['init_timestamp'] = datetime.now()
        tentativeSubjectUpdates = self._state.tentativeSubjectUpdatesCache.get(request['obj1Id'])
        if tentativeSubjectUpdates:
            request['tentativeSubjectUpdates'] = tentativeSubjectUpdates
        updatesFromSubjectCache = self._state.cache.get(request['obj1Id'])
        if updatesFromSubjectCache:
            request['updatesFromSubjectCache'] = updatesFromSubjectCache
        coord = mapper.getCoordinator(request['obj2Id'], self._state.coordIndexToCoordProcessMapper)
        self.optimizedSend('RESOURCE_COORDINATOR_INITIAL', request, coord)

    def processNewRequestResource(self, request):
        updatesFromResourceCache = self._state.cache.get(request['obj2Id'])
        if updatesFromResourceCache:
            request['updatesFromResourceCache'] = updatesFromResourceCache
        self._state.messagesSent += 1
        worker = random.choice(self._state.workersList)
        self._state.logger.write(((((self._state.name + " sending ('WORKER_INITIAL', ") + str(request)) + ') to ') + str(worker)))
        self.send(('WORKER_INITIAL', request), to=worker)

    def processRequestResourceConflict(self, request):
        request['numRestarts'] += 1
        self._state.logger.write(((self._state.name + ': Abort and restart due to resource conflict. Request was: ') + str(request)))
        self._state.abortedRequestIds.append(request['requestId'])
        self._state.tentativeSubjectUpdatesCache.remove(request['obj1Id'], request['requestId'])
        self._state.ongoingRequestIds.remove(request['requestId'])
        self.resetRequestObject(request)
        coord = mapper.getCoordinator(request['obj1Id'], self._state.coordIndexToCoordProcessMapper)
        self.optimizedSend('SUBJECT_COORDINATOR_INITIAL', request, coord)

    def processRequestSubjectFinal(self, request):
        self._state.logger.write(((self._state.name + ': Commit. Send success to client. Request was: ') + str(request)))
        toCommit = False
        if (len(request['attributeUpdates']['obj1']) > 0):
            self._state.logger.write(((((('Updating database for request ' + request['requestId']) + ', with updates (for id: ') + str(request['obj1Id'])) + '): ') + str(request['attributeUpdates']['obj1'])))
            ret = self._state.db.updateNormal(request['obj1Id'], request['attributeUpdates']['obj1'])
            toCommit = True
            self._state.cache.put(Update(request['obj1Id'], request['attributeUpdates']['obj1'], request['init_timestamp'], request['requestId']))
            '\n            if not ret:\n                print("Problem with obj1")\n                print(request)\n                if \'updatesFromSubjectCache\' in request:\n                    print("original piggyback: " + str(request[\'updatesFromSubjectCache\']))\n                if \'tentativeSubjectUpdates\' in request:\n                    print("tentative piggyback: ")\n                    debug1(request[\'tentativeSubjectUpdates\'])\n                print("current cache: " + str(self.cache.get(request[\'obj1Id\'])))\n                print()\n            '
        self._state.tentativeSubjectUpdatesCache.remove(request['obj1Id'], request['requestId'])
        self.resetRequestObject(request)
        self._state.ongoingRequestIds.remove(request['requestId'])
        self._state.networkMessagesSent += 1
        self._state.messagesSent += 1
        self._state.logger.write(((((self._state.name + " sending ('CLIENT_RESULT, ") + str(request)) + "') to ") + str(request['client'])))
        self.send(('CLIENT_RESULT', request), to=request['client'])
        if toCommit:
            self._state.db.commit()

    def processRequestResourceValidate(self, request):
        coord = mapper.getCoordinator(request['obj1Id'], self._state.coordIndexToCoordProcessMapper)
        toCommit = False
        if self.cacheHasDifferentValues(request['obj2Id'], self._state.cache, request['readAttributes']['obj2']):
            self._state.logger.write(((self._state.name + ': Notify subject coordinator of resource conflict. Request was: ') + str(request)))
            self.optimizedSend('SUBJECT_COORDINATOR_RESOURCE_CONFLICT', request, coord)
        else:
            if (len(request['attributeUpdates']['obj2']) > 0):
                self._state.cache.put(Update(request['obj2Id'], request['attributeUpdates']['obj2'], request['init_timestamp'], request['requestId']))
                self._state.logger.write(((((('Updating database for request ' + request['requestId']) + ', with updates(for id: ') + str(request['obj2Id'])) + '): ') + str(request['attributeUpdates']['obj2'])))
                ret = self._state.db.updateNormal(request['obj2Id'], request['attributeUpdates']['obj2'])
                toCommit = True
                '\n                if not ret:\n                    print("Problem with obj2")\n                    print(request)\n                    if \'updatesFromResourceCache\' in request:\n                        print("original piggyback: " + str(request[\'updatesFromResourceCache\']))\n                    print()\n                '
            self._state.logger.write(((self._state.name + ': No conflict. Request is: ') + str(request)))
            self.optimizedSend('SUBJECT_COORDINATOR_FINAL', request, coord)
        if toCommit:
            self._state.db.commit()

    def waitOn(self, request):
        requestIds = []
        readAttrs = request['readAttributes']['obj1']
        if ('tentativeSubjectUpdates' in request):
            for (requestId, update) in request['tentativeSubjectUpdates'].items():
                for readAttr in readAttrs:
                    if (readAttr in update.attrs):
                        requestIds.append(requestId)
        cached = self._state.tentativeSubjectUpdatesCache.get(request['obj1Id'])
        for attr in readAttrs:
            for (requestId, update) in cached.items():
                if (attr in update.attrs):
                    if (not (update.attrs[attr] == readAttrs[attr])):
                        requestIds.append(requestId)
        return requestIds

    def shouldRestart(self, request):
        readAttrs = request['readAttributes']['obj1']
        if ('tentativeSubjectUpdates' in request):
            for (requestId, update) in request['tentativeSubjectUpdates'].items():
                for readAttr in readAttrs:
                    if ((readAttr in update.attrs) and (requestId in self._state.abortedRequestIds)):
                        return True
        return False

    def cacheHasDifferentValues(self, cacheKey, cache, readAttrs):
        cached = cache.get(cacheKey)
        if cached:
            cachedAttrs = cached
        else:
            return False
        try:
            if (type(cached) is dict):
                for attr in readAttrs:
                    for (requestId, update) in cached.items():
                        if (attr in update.attrs):
                            if (not (update.attrs[attr] == readAttrs[attr])):
                                self._state.logger.write(((((('For attribute ' + str(attr)) + ', value used for policy evaluation was ') + str(readAttrs[attr])) + ', but value in cache is ') + str(update.attrs[attr])))
                                return True
                pass
            else:
                cachedAttrs = cached.attrs
                for attr in readAttrs:
                    if (attr in cachedAttrs):
                        if (not (cachedAttrs[attr] == readAttrs[attr])):
                            self._state.logger.write(((((('For attribute ' + str(attr)) + ', value used for policy evaluation was ') + str(readAttrs[attr])) + ', but value in cache is ') + str(cachedAttrs[attr])))
                            return True
            return False
        except:
            print('_____________________0000__________')
            raise

    def resetRequestObject(self, request):
        attrsToKeep = ['obj1Id', 'obj2Id', 'action', 'client', 'requestId', 'numRestarts', 'startTime']
        attrsToDelete = []
        for key in request:
            if (not (key in attrsToKeep)):
                attrsToDelete.append(key)
        for key in attrsToDelete:
            del request[key]

    def intersect(self, l1, l2):
        s2 = set(l2)
        l3 = [val for val in l1 if (val in s2)]
        return l3

    def sleepIfRequested(self, state, request):
        return
        if (state in request['delay']):
            delay = int(request['delay'][state])
            self._state.logger.write((((self._state.name + ' sleeping for ') + str(delay)) + ' second(s)'))
            time.sleep(delay)
        if (state in request['delay']):
            self._state.logger.write((self._state.name + ' resumed from sleeping'))

    def usedTentativeSubjectAttributes(self, request):
        readAttrs = request['readAttributes']['obj1']
        if ('tentativeSubjectUpdates' in request):
            for (requestId, update) in request['tentativeSubjectUpdates'].items():
                for readAttr in readAttrs:
                    if (readAttr in update.attrs):
                        return True
        return False

    def _Coordinator_handler_3084(self, stats, p):
        self._state.workersStats.append(stats)
        self._state.numStatsReceivedFromWorker += 1
        if (self._state.numStatsReceivedFromWorker == len(self._state.workersList)):
            self._state.endCPUTime = time.process_time()
            CPUTime = (self._state.endCPUTime - self._state.startCPUTime)
            stats = {'name': self._state.name, 'networkMessagesSent': self._state.networkMessagesSent, 'messagesSent': self._state.messagesSent, 'CPUTime': CPUTime, 'workers': self._state.workersStats}
            self._state.db.disconnect()
            self.send(('STATS_RESULT', stats), to=self._state.master)
            self._state.finished = True
    _Coordinator_handler_3084._labels = None
    _Coordinator_handler_3084._notlabels = None

    def _Coordinator_handler_3174(self, p):
        for worker in self._state.workersList:
            self.send(('GET_STATS',), to=worker)
    _Coordinator_handler_3174._labels = None
    _Coordinator_handler_3174._notlabels = None

    def _Coordinator_handler_3196(self, request, p):
        state = 'SUBJECT_COORDINATOR_INITIAL'
        self._state.logger.write(((((((self._state.name + " received ('") + state) + "', ") + str(request)) + ') from ') + str(p)))
        self.sleepIfRequested(state, request)
        self.processNewRequestSubject(request)
    _Coordinator_handler_3196._labels = None
    _Coordinator_handler_3196._notlabels = None

    def _Coordinator_handler_3248(self, request, p):
        state = 'RESOURCE_COORDINATOR_INITIAL'
        self._state.logger.write(((((((self._state.name + " received ('") + state) + "', ") + str(request)) + ') from ') + str(p)))
        self.sleepIfRequested(state, request)
        self.processNewRequestResource(request)
    _Coordinator_handler_3248._labels = None
    _Coordinator_handler_3248._notlabels = None

    def _Coordinator_handler_3300(self, request, p):
        state = 'SUBJECT_COORDINATOR_VALIDATE'
        self._state.logger.write(((((((self._state.name + " received ('") + state) + "', ") + str(request)) + ') from ') + str(p)))
        self.sleepIfRequested(state, request)
        if self.cacheHasDifferentValues(request['obj1Id'], self._state.cache, request['readAttributes']['obj1']):
            request['numRestarts'] += 1
            self.resetRequestObject(request)
            self._state.ongoingRequestIds.remove(request['requestId'])
            coord = mapper.getCoordinator(request['obj1Id'], self._state.coordIndexToCoordProcessMapper)
            newState = 'SUBJECT_COORDINATOR_INITIAL'
            self._state.logger.write(((self._state.name + ': Abort and restart due to subject conflict. Request was: ') + str(request)))
            self.processNewRequestSubject(request)
            return
        if (self.usedTentativeSubjectAttributes(request) or self.cacheHasDifferentValues(request['obj1Id'], self._state.tentativeSubjectUpdatesCache, request['readAttributes']['obj1'])):
            ongoingWaitOn = self.intersect(self.waitOn(request), self._state.ongoingRequestIds)
            if (len(ongoingWaitOn) > 0):
                self._state.logger.write(((('Request with requestId: ' + request['requestId']) + 'has to Wait on ') + str(ongoingWaitOn)))
            super()._label('_st_label_3468', block=False)
            _st_label_3468 = 0
            while (_st_label_3468 == 0):
                _st_label_3468 += 1
                if (len(self.intersect(self.waitOn(request), self._state.ongoingRequestIds)) == 0):
                    _st_label_3468 += 1
                else:
                    super()._label('_st_label_3468', block=True)
                    _st_label_3468 -= 1
            if self.shouldRestart(request):
                request['numRestarts'] += 1
                self._state.ongoingRequestIds.remove(request['requestId'])
                coord = mapper.getCoordinator(request['obj1Id'], self._state.coordIndexToCoordProcessMapper)
                newState = 'SUBJECT_COORDINATOR_INITIAL'
                self._state.logger.write(((((self._state.name + ": Abort and restart due to dependency on tentative update that didn't succeed. Request was: ") + str(request)) + '. Depended on tentativeUpdates ') + str(request['tentativeSubjectUpdates'])))
                self.resetRequestObject(request)
                self.processNewRequestSubject(request)
                return
        if self.cacheHasDifferentValues(request['obj1Id'], self._state.cache, request['readAttributes']['obj1']):
            request['numRestarts'] += 1
            self.resetRequestObject(request)
            self._state.ongoingRequestIds.remove(request['requestId'])
            coord = mapper.getCoordinator(request['obj1Id'], self._state.coordIndexToCoordProcessMapper)
            newState = 'SUBJECT_COORDINATOR_INITIAL'
            self._state.logger.write(((self._state.name + ': Abort and restart due to subject conflict. Request was: ') + str(request)))
            self.processNewRequestSubject(request)
            return
        if (request['result'] == False):
            self._state.ongoingRequestIds.remove(request['requestId'])
            self.resetRequestObject(request)
            self._state.networkMessagesSent += 1
            self._state.messagesSent += 1
            self._state.logger.write(((((self._state.name + " sending ('CLIENT_RESULT, ") + str(request)) + "') to ") + str(request['client'])))
            self.send(('CLIENT_RESULT', request), to=request['client'])
        else:
            if (len(request['attributeUpdates']['obj1']) > 0):
                self._state.tentativeSubjectUpdatesCache.put(Update(request['obj1Id'], request['attributeUpdates']['obj1'], request['init_timestamp'], request['requestId']))
            coord = mapper.getCoordinator(request['obj2Id'], self._state.coordIndexToCoordProcessMapper)
            self._state.logger.write(((((self._state.name + " sending ('RESOURCE_COORDINATOR_VALIDATE', ") + str(request)) + ') to ') + str(coord)))
            self.optimizedSend('RESOURCE_COORDINATOR_VALIDATE', request, coord)
    _Coordinator_handler_3300._labels = None
    _Coordinator_handler_3300._notlabels = None

    def _Coordinator_handler_3824(self, request, p):
        state = 'SUBJECT_COORDINATOR_RESOURCE_CONFLICT'
        self._state.logger.write(((((((self._state.name + " received ('") + state) + "', ") + str(request)) + ') from ') + str(p)))
        self.sleepIfRequested(state, request)
        self.processRequestResourceConflict(request)
    _Coordinator_handler_3824._labels = None
    _Coordinator_handler_3824._notlabels = None

    def _Coordinator_handler_4055(self, request, p):
        state = 'SUBJECT_COORDINATOR_FINAL'
        self._state.logger.write(((((((self._state.name + " received ('") + state) + "', ") + str(request)) + ') from ') + str(p)))
        self.sleepIfRequested(state, request)
        self.processRequestSubjectFinal(request)
    _Coordinator_handler_4055._labels = None
    _Coordinator_handler_4055._notlabels = None

    def _Coordinator_handler_4271(self, request, p):
        state = 'RESOURCE_COORDINATOR_VALIDATE'
        self._state.logger.write(((((((self._state.name + " received ('") + state) + "', ") + str(request)) + ') from ') + str(p)))
        self.sleepIfRequested(state, request)
        self.processRequestResourceValidate(request)
    _Coordinator_handler_4271._labels = None
    _Coordinator_handler_4271._notlabels = None

class Master(da.DistProcess):

    def __init__(self, procimpl, props):
        super().__init__(procimpl, props)
        self._events.extend([da.pat.EventPattern(da.pat.ReceivedEvent, '_MasterReceivedEvent_0', PatternExpr_5058, sources=[PatternExpr_5064], destinations=None, timestamps=None, record_history=None, handlers=[self._Master_handler_5057]), da.pat.EventPattern(da.pat.ReceivedEvent, '_MasterReceivedEvent_1', PatternExpr_5123, sources=[PatternExpr_5129], destinations=None, timestamps=None, record_history=None, handlers=[self._Master_handler_5122])])

    def setup(self, config, master, **rest_5759):
        super().setup(config=config, master=master, **rest_5759)
        self._state.config = config
        self._state.master = master
        self._state.config = self._state.config
        self._state.master = self._state.master
        self._state.finished = False
        self.createFolderIfNotExists(Filenames.getStatsFolderName(self._state.config))
        self.createFolderIfNotExists(Filenames.getLogsFolderName(self._state.config))
        self._state.logger = Logger(Filenames.getMasterLogFilename(self._state.config))
        self._state.numStatsReceivedFromCoord = 0
        self._state.coordIndexToCoordProcessMapper = None
        self._state.name = '<Master>'
        self._state.numClientsDone = 0
        self._state.stats = {'coordinators': {'list': []}, 'aggregate': {}}
        self._state.logger.write('Trying to set up database for Decat Experiment')
        dbMaster = MySQLAbstraction(MASTER_DB_USER, MASTER_DB_PASS, MASTER_DB_HOST)
        dbMaster.connect()
        dbMaster.getCursor()
        dbMaster.dropDB(DB_NAME)
        dbMaster.createDB(DB_NAME)
        dbMaster.commit()
        dbMaster.selectDB(DB_NAME)
        dbMaster.createTableDecat(TABLE_NAME, 10, int(self._state.config['nObj']))
        dbMaster.setTableName(TABLE_NAME)
        dbMaster.disconnect()
        self._state.logger.write('Database set up complete')
        self._state.logger.write('Trying to create coordinators')
        coord2 = self.new(Coordinator, num=1, at=COORD2NODE)
        print('coord2 resolved')
        coord1 = self.new(Coordinator, num=1)
        self._state.logger.write('Coordinators created')
        self._state.coordIndexToCoordProcessMapper = {}
        self._state.coordIndexToCoordProcessMapper[1] = list(coord1)[0]
        self._state.coordIndexToCoordProcessMapper[2] = list(coord2)[0]
        self._state.logger.write('Trying to set up coordinators')
        for i in range(1, (1 + 2)):
            coord = self._state.coordIndexToCoordProcessMapper[i]
            self._setup(coord, (self._state.coordIndexToCoordProcessMapper, self._state.config, i, self._id))
        self._state.clientMaster = self.new(ClientMaster, num=1, at=CLIENTNODE)
        print('client resolved')
        self._setup(self._state.clientMaster, (self._state.coordIndexToCoordProcessMapper, self._state.config, self._id))

    def run(self):
        self._state.logger.write('Starting coordinator 1')
        self._start(self._state.coordIndexToCoordProcessMapper[1])
        self._state.logger.write('Starting coordinator 2')
        self._start(self._state.coordIndexToCoordProcessMapper[2])
        self._state.logger.write('Starting client Master')
        self._start(self._state.clientMaster)
        super()._label('_st_label_5472', block=False)
        _st_label_5472 = 0
        while (_st_label_5472 == 0):
            _st_label_5472 += 1
            if self._state.finished:
                _st_label_5472 += 1
            else:
                super()._label('_st_label_5472', block=True)
                _st_label_5472 -= 1

    def getSeed(self):
        seed = int.from_bytes(os.urandom(32), 'big')
        return seed

    def createFolderIfNotExists(self, folderName):
        directory = os.path.dirname(folderName)
        if (not os.path.exists(directory)):
            os.makedirs(directory)

    def _Master_handler_5057(self, stats, p):
        self._state.logger.write(((((self._state.name + " received ('ALL_CLIENTS_DONE', ") + str(stats)) + ') from ') + str(p)))
        self._state.stats.update(stats)
        self.send(('GET_STATS',), to=self._state.coordIndexToCoordProcessMapper[1])
        self.send(('GET_STATS',), to=self._state.coordIndexToCoordProcessMapper[2])
        self._state.logger.write('All clients done')
    _Master_handler_5057._labels = None
    _Master_handler_5057._notlabels = None

    def _Master_handler_5122(self, stats, p):
        self._state.logger.write(((((self._state.name + " received ('STATS_RESULT', ") + str(stats)) + ') from ') + str(p)))
        self._state.stats['coordinators']['list'].append(stats)
        self._state.numStatsReceivedFromCoord += 1
        if (self._state.numStatsReceivedFromCoord == 2):
            totalMessagesSent = 0
            totalNetworkMessagesSent = 0
            totalMessagesSent += self._state.stats['clients']['aggregate']['messagesSent']
            for coordStats in self._state.stats['coordinators']['list']:
                totalNetworkMessagesSent += coordStats['networkMessagesSent']
                totalMessagesSent += coordStats['messagesSent']
                for workerStats in coordStats['workers']:
                    totalMessagesSent += workerStats['messagesSent']
                    totalNetworkMessagesSent += workerStats['networkMessagesSent']
            totalNetworkMessagesSent += self._state.stats['clients']['aggregate']['messagesSent']
            self._state.stats['aggregate']['numRequests'] = int(self._state.config['nRequest'])
            self._state.stats['aggregate']['totalMessagesSent'] = totalMessagesSent
            self._state.stats['aggregate']['totalNetworkMessagesSent'] = totalNetworkMessagesSent
            self._state.stats['aggregate']['messagesPerRequest'] = (totalMessagesSent / int(self._state.config['nRequest']))
            self._state.stats['aggregate']['networkMessagesPerRequest'] = (totalNetworkMessagesSent / int(self._state.config['nRequest']))
            self._state.stats['aggregate']['processingTime'] = self._state.stats['clients']['aggregate']['processingTime']
            self._state.stats['aggregate']['throughput'] = (int(self._state.config['nRequest']) / self._state.stats['aggregate']['processingTime'])
            self._state.stats['seed'] = self._state.config['seedBaseDecat']
            self._state.stats['timeResolutionGranularity'] = time.get_clock_info('perf_counter').resolution
            pickle_out = open(Filenames.getPickleFilename(self._state.config), 'wb')
            pickle.dump(self._state.stats, pickle_out)
            pickle_out.close()
            readeableFile = open(Filenames.getStatsFilename(self._state.config), 'w')
            readeableFile.write(pformat(self._state.stats))
            readeableFile.close()
            self.send(('MASTER_DONE',), to=self._state.master)
            self._state.finished = True
    _Master_handler_5122._labels = None
    _Master_handler_5122._notlabels = None

class MasterMaster(da.DistProcess):

    def __init__(self, procimpl, props):
        super().__init__(procimpl, props)
        self._events.extend([da.pat.EventPattern(da.pat.ReceivedEvent, '_MasterMasterReceivedEvent_0', PatternExpr_5549, sources=[PatternExpr_5554], destinations=None, timestamps=None, record_history=None, handlers=[self._MasterMaster_handler_5548])])

    def setup(self, config, **rest_5759):
        super().setup(config=config, **rest_5759)
        self._state.config = config
        self._state.config = self._state.config
        self._state.currentExperiment = 0
        self._state.experimentsDone = 0
        self._state.finished = False

    def run(self):
        print('MasterMaster running')
        self.startNextExperiment()
        super()._label('_st_label_5672', block=False)
        _st_label_5672 = 0
        while (_st_label_5672 == 0):
            _st_label_5672 += 1
            if self._state.finished:
                _st_label_5672 += 1
            else:
                super()._label('_st_label_5672', block=True)
                _st_label_5672 -= 1
        print('All experiments ran successfully')
        self.send(('MASTERMASTER_DONE',), to=self.nodeof(self._id))

    def startNextExperiment(self):
        config_ = self._state.config['experiments'][self._state.currentExperiment]
        for attr in self._state.config:
            if (not (attr == 'experiments')):
                config_[attr] = self._state.config[attr]
        self._state.currentExperiment += 1
        master = self.new(Master, num=1)
        print('setting up master')
        self._setup(master, (config_, self._id))
        print('Running Experiment', self._state.currentExperiment, '/', len(self._state.config))
        self._start(master)

    def _MasterMaster_handler_5548(self, p):
        self._state.experimentsDone += 1
        print('Experiment', self._state.experimentsDone, 'done')
        print()
        if (self._state.experimentsDone == len(self._state.config['experiments'])):
            self._state.finished = True
        else:
            self.startNextExperiment()
    _MasterMaster_handler_5548._labels = None
    _MasterMaster_handler_5548._notlabels = None

def print_usage():
    print('Usage: python3 -m da main.da <config>')

class Node_(da.NodeProcess):

    def __init__(self, procimpl, props):
        super().__init__(procimpl, props)
        self._Node_ReceivedEvent_0 = []
        self._events.extend([da.pat.EventPattern(da.pat.ReceivedEvent, '_Node_ReceivedEvent_0', PatternExpr_5744, sources=None, destinations=None, timestamps=None, record_history=True, handlers=[])])
    _config_object = {'channel': 'fifo'}

    def run(self):
        if (not (len(sys.argv) == 2)):
            print_usage()
            self.exit()
        configFile = open(sys.argv[1])
        configFile = json.load(configFile)
        mastermaster = self.new(MasterMaster, num=1)
        self._setup(mastermaster, (configFile,))
        self._start(mastermaster)
        super()._label('_st_label_5741', block=False)
        _st_label_5741 = 0
        while (_st_label_5741 == 0):
            _st_label_5741 += 1
            if PatternExpr_5749.match_iter(self._Node_ReceivedEvent_0):
                _st_label_5741 += 1
            else:
                super()._label('_st_label_5741', block=True)
                _st_label_5741 -= 1
