# Use this file to know what this requests entails in terms of
# attributes read, written, which obj to write, etc.
# attribute of the request
# Do NOT use this in coordinator; the encoded info is only for worker
# as a replacement for contacting the policy evaluator

'''
Which subject (obj1) attrs will be read: returns a list, for example,  ['a2', 'a3', ...]
'''
def getObj1AttrsToRead(request):
    return ['a' + attrNum for attrNum in request['action'][3:6] if attrNum != '-']

'''
Which resource (obj2) attrs will be read: returns a list, for example,  ['a7', 'a8', ...]
Note: it also includes the attr to be written since that attr
has to be read if it has to be incremented
'''
def getObj2AttrsToRead(request):
    return ['a' + attrNum for attrNum in request['action'][6:9] if attrNum != '-']

'''
Which object to write
Returns 1 or 2 (int)
'''
def getObjectToWrite(request):
    return int(request['action'][1]) if request['action'][0] == 'w' else None

'''
Is this a read request?
'''
def isReadRequest(request):
    return request['action'][0] == 'r'

'''
Is this a write request?
'''
def isWriteRequest(request):
    return request['action'][0] == 'w'

'''
If this is a write request
get the attr that will be written
E.g. 'a1'
'''
def getAttrToWrite(request):
    return 'a' + request['action'][2] if isWriteRequest(request) else None


def getMightReadAttr(request):
    return request['mightReadAttr']