# this is used throughout the program to get the right coordinator
# for a particular subject or resource by their id

import hashlib
NUMCOORD = 2

def getCoordinatorIndex(id):
    return int(hashlib.sha256(str(id).encode('utf-8')).hexdigest(), 16) % NUMCOORD + 1

def getCoordinator(id, coordIndexToCoordProcessMapper):
    index = getCoordinatorIndex(id)
    return coordIndexToCoordProcessMapper[index]

# returns id of the object for whose coordinator should process the request first (if i==1) or 
# second (if i==2)
def getObjId(request, i):
    if (len(request['mightWriteObj']) >= 1):
        # note: if len==2, we only consider the 0th element of the list
        # to be the written object
        # this requires that we don't always put the written object at
        # the front of this list when generating the request in RequestGeneratorMVCCTSO
        # when it contains an extra mightWriteObj (so that we can sometimes cause incorrect prediction)
        writtenObjectId = request['mightWriteObj'][0]
        otherObjectId = request['obj1Id'] if writtenObjectId == request['obj2Id'] else request['obj2Id']

        return writtenObjectId if i == 2 else otherObjectId
    else:
        # read request
        # note: hardcoded
        return request['obj1Id'] if i == 1 else request['obj2Id']

